#!/bin/bash
source $srcdir/testsuite/runtest.sh

echo "version 0 of test file" >testfile
check_exec "$MT add testfile" 0
check_exec "$MT --branch=testbranch commit blah-blah" 0
ROOT_M_SHA=$(sha1 MT/manifest)
ROOT_F_SHA=$(sha1 testfile)

echo "left version of fork" >testfile
check_exec "$MT commit blah-blah" 0
LEFT_M_SHA=$(sha1 MT/manifest)
LEFT_F_SHA=$(sha1 testfile)
check_nonequal $ROOT_M_SHA $LEFT_M_SHA
check_nonequal $ROOT_F_SHA $LEFT_F_SHA

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $ROOT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $ROOT_M_SHA $PROBE_M_SHA
check_equal $ROOT_F_SHA $PROBE_F_SHA

echo "right version of fork" >testfile
check_exec "$MT commit blah-blah" 0
RIGHT_M_SHA=$(sha1 MT/manifest)
RIGHT_F_SHA=$(sha1 testfile)
check_nonequal $ROOT_M_SHA $RIGHT_M_SHA
check_nonequal $ROOT_F_SHA $RIGHT_F_SHA
check_nonequal $LEFT_M_SHA $RIGHT_M_SHA
check_nonequal $LEFT_F_SHA $RIGHT_F_SHA

# fork committed ok. now check to make sure
# all 3 nodes are reconstructable

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $ROOT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $ROOT_M_SHA $PROBE_M_SHA
check_equal $ROOT_F_SHA $PROBE_F_SHA

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $LEFT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $LEFT_M_SHA $PROBE_M_SHA
check_equal $LEFT_F_SHA $PROBE_F_SHA

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $RIGHT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $RIGHT_M_SHA $PROBE_M_SHA
check_equal $RIGHT_F_SHA $PROBE_F_SHA
