#!/bin/bash
source $srcdir/testsuite/runtest.sh

# this test is kinda like update, only it *does* commit the left right
# branch before attempting a merge. it just checks to make sure merging
# works in the context of the "merge" command, not just the "update"
# command.

cat >testfile <<EOF
first line of the file
second line of the file
third line of the file
EOF
check_exec "$MT add testfile" 0
check_exec "$MT --branch=testbranch commit blah-blah" 0
ROOT_M_SHA=$(sha1 MT/manifest)
ROOT_F_SHA=$(sha1 testfile)

cat >testfile <<EOF
first line of the file
an insertion between first and second
second line of the file
third line of the file
EOF
check_exec "$MT commit blah-blah" 0
LEFT_M_SHA=$(sha1 MT/manifest)
LEFT_F_SHA=$(sha1 testfile)
check_nonequal $ROOT_M_SHA $LEFT_M_SHA
check_nonequal $ROOT_F_SHA $LEFT_F_SHA

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $ROOT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $ROOT_M_SHA $PROBE_M_SHA
check_equal $ROOT_F_SHA $PROBE_F_SHA

cat >testfile <<EOF
first line of the file
second line of the file
an insertion between second and third
third line of the file
EOF
check_exec "$MT commit blah-blah" 0
RIGHT_M_SHA=$(sha1 MT/manifest)
RIGHT_F_SHA=$(sha1 testfile)
check_nonequal $ROOT_M_SHA $RIGHT_M_SHA
check_nonequal $ROOT_F_SHA $RIGHT_F_SHA
check_nonequal $LEFT_M_SHA $RIGHT_M_SHA
check_nonequal $LEFT_F_SHA $RIGHT_F_SHA

# files should now be merged
check_exec "$MT --branch=testbranch merge" 0
check_exec "$MT update" 0
cat >probe <<EOF
first line of the file
an insertion between first and second
second line of the file
an insertion between second and third
third line of the file
EOF
check_exec "cmp testfile probe" 0

