#!/bin/bash
source $srcdir/testsuite/runtest.sh

# this script uses the 'sn' news server and the 'tcpserver' network package 
# from ucspi-tcp. if you do not have them installed, it will fail.

echo "version 0 of test file" >testfile
check_exec "$MT add testfile" 0
check_exec "$MT --branch=testbranch commit blah-blah" 0
VER0=$(sha1 MT/manifest)

check_exec "cp test.db test2.db" 0

echo "version 1 of test file" >testfile
check_exec "$MT commit blah-blah" 0
VER1=$(sha1 MT/manifest)

export SNROOT=`pwd`/snroot
export POSTING_OK=''

PORT=8119
HOST=127.0.0.1
GROUP=monotone.test.packets

check_exec "mkdir -p $SNROOT" 0
check_exec "snnewgroup $GROUP" 0
check_exec "tcpserver $HOST $PORT snntpd &" 0
TCPSERVER_PID=$!
sleep 2
check_exec "$MT post" 0

check_exec "sncat $GROUP | grep mdelta | grep $VER0" 0

check_exec "$MT --db=test2.db fetch $HOST:$PORT $GROUP" 0
check_exec "$MT --db=test2.db mdata $VER0 | grep mdata" 0

check_exec "kill -TERM $TCPSERVER_PID" 0

