#!/bin/bash
source $srcdir/testsuite/runtest.sh

# this script checks to see if persistent keys work

cat >test_hooks.lua <<EOF
function ignore_file(name)
	if (strfind(name, "%.lua$")) then return 1 end
	if (strfind(name, "%.db$")) then return 1 end
        return nil;
end

function get_author(branchname)
        local user = getenv("USER");
        local host = getenv("HOSTNAME");
        if ((user == nil) or (host == nil)) then return nil; end
        return format("%s@%s", user, host)
end

function non_blocking_rng_ok()
	return 1;
end

function persist_phrase_ok()
	return 1;
end

function get_branch_key(branchname)
	return "tester@test.net";
end

function get_newsserver(branchname)
	return "127.0.0.1:8119";
end

function get_newsgroup(branchname)
	return "monotone.test.packets";
end

function get_sender(server, newsgroup)
	return "tester@test.com";
end
EOF

echo "blah" > input.txt
SHA=$(sha1 input.txt)
check_exec "$MT import input.txt" 0
echo "blah blah blah" > input.txt
check_exec "echo 'tester@test.net' | $MT --branch=testbranch commit blah-blah" 0

MSHA=$(sha1 MT/manifest)
check_exec "$MT lscerts manifest $MSHA | grep ancestor" 0
check_exec "$MT lscerts manifest $MSHA | grep branch" 0
check_exec "$MT lscerts manifest $MSHA | grep author" 0
check_exec "$MT lscerts manifest $MSHA | grep date" 0
check_exec "$MT lscerts manifest $MSHA | grep changelog" 0
