#!/bin/bash
source $srcdir/testsuite/runtest.sh

# this test is kinda like fork, only it doesn't commit the right side of 
# the fork; instead, it updates, and (in theory) shifts from right to merged-with-left

cat >testfile <<EOF
first line of the file
second line of the file
third line of the file
EOF
check_exec "$MT add testfile" 0
check_exec "$MT --branch=testbranch commit blah-blah" 0
ROOT_M_SHA=$(sha1 MT/manifest)
ROOT_F_SHA=$(sha1 testfile)

cat >testfile <<EOF
first line of the file
an insertion between first and second
second line of the file
third line of the file
EOF
check_exec "$MT commit blah-blah" 0
LEFT_M_SHA=$(sha1 MT/manifest)
LEFT_F_SHA=$(sha1 testfile)
check_nonequal $ROOT_M_SHA $LEFT_M_SHA
check_nonequal $ROOT_F_SHA $LEFT_F_SHA

check_exec "rm MT/manifest" 0
check_exec "rm testfile" 0
check_exec "$MT checkout $ROOT_M_SHA" 0
PROBE_M_SHA=$(sha1 MT/manifest)
PROBE_F_SHA=$(sha1 testfile)
check_equal $ROOT_M_SHA $PROBE_M_SHA
check_equal $ROOT_F_SHA $PROBE_F_SHA

cat >testfile <<EOF
first line of the file
second line of the file
an insertion between second and third
third line of the file
EOF
check_exec "$MT update" 0

# files should now be merged
cat >probe <<EOF
first line of the file
an insertion between first and second
second line of the file
an insertion between second and third
third line of the file
EOF
check_exec "cmp testfile probe" 0

